/* 
	* Shotgun war
	*
+	* Lower gravity
+	* Higher speed
+	* Level up system?
+	* only M3 and knife
	* gun upgrade system
+	* wall jump
+	* no knockback
+	* stealth mode (equips knife, on curweapon gets turned off)
+	* pull to player (some time for cooldwon)
+	* more damage with higher speed
+	* armor regen, hp damage only when armour is destroyed
+	* Unlimited bullet count
+	* push back both players on collision (different teams)
+	* no fall dmg
+	* no buy zone
*/

#include <amxmodx>
#include <fun>
#include <hamsandwich>
#include <engine>
#include <fakemeta>
#include <cstrike>
#include <xs>

#define PLUGIN "shotgun war"
#define VERSION "1.0"
#define AUTHOR "MPD"

#if cellbits == 32
	#define OFFSET 235
#else
	#define OFFSET 268
#endif

#define ARMOR	 700
#define PULL	 800
#define ID	1000

#define SetTrue(%1,%2) (%1 |= 1<<(%2&31))
#define SetFalse(%1,%2) (%1 &= ~1<<(%2&31))
#define IsTrue(%1,%2) (%1 & 1<<(%2&31))

// Consts
new const g_iWeapons[] = {2, 4, 6, 7, 9};
new const g_szWeapons[][] = {
	"Bersek",
	"Piercer",
	"Vanisher",
	"Heavy",
	"Brutality"
};
// Messages
new g_msg_icon, g_msg_shadow, g_msg_ScreenFade, g_msg_say_text;
// Cvar pointers
new pSpeed, pStealthCoolDown, pStealthTime, pPullCoolDown, /*pHoldJumpSpeed, pWallJumpSpeed,*/ pArmor;
new pArmorRegenRate, pArmorRegen, pDmgMulti, pMinSpeed, pMaxSpeed, pJumps, pArmorLoss, pAutoBhop;
new pPullDistance, pAddHp, pAddArmor, pAddRegen;
// Global Varibles
new bool: g_bStart;
new g_bFalling, g_bWallBlock, g_bJump, g_bStealth, g_bInStealth, g_bPull, g_bScreenFade, g_bChosen;
new g_bHasGun, g_bPushPerformed;
new Float:g_Knockback[32][3], Float: g_fVelocity[32][3];
new g_iJumpCount[32], g_iAirKills[32][2];
// Level up system
new g_iKills[32], g_iLvl[32], g_iHp[32], g_iArmor[32], g_iPts[32], Float: g_fRegen[32];

// Precache
new const g_szSoundVanish[] = "sw/flyby.wav";
new const g_szSoundVanishReverse[] = "sw/flybyreverse.wav";
new const g_szSoundRic[] = "weapons/ric_conc-1.wav";

public plugin_precache(){
	precache_sound(g_szSoundVanish);
	precache_sound(g_szSoundVanishReverse);
	precache_sound(g_szSoundRic);
}

public pfn_keyvalue(iEnt){
	new szClassName[20], temp[2];
	copy_keyvalue(szClassName, charsmax(szClassName), temp, charsmax(temp), temp, charsmax(temp));
	if (equal(szClassName, "func_bomb_target") || equal(szClassName, "hostage_entity")){
		remove_entity(iEnt);
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)
//------Commands
	register_clcmd("say /upgrades", "Upgrades");
	register_clcmd("say /level", "Level");
	register_clcmd("drop", "Drop");
//------Cvars
	pAutoBhop = register_cvar("sw_auto_bhop", "0");
	pJumps = register_cvar("sw_jumps", "3");
	pSpeed = register_cvar("sw_speed", "640");
	pStealthCoolDown = register_cvar("sw_stealth_cooldown", "20.0");
	pStealthTime = register_cvar("sw_stealth_time", "4.0");
	pPullCoolDown = register_cvar("sw_pull_cooldown", "20.0");
	pPullDistance = register_cvar("sw_pull_distance", "512");
	pAddHp = register_cvar("sw_add_hp", "10");
	pAddArmor = register_cvar("sw_add_armor", "3");
	pAddRegen = register_cvar("sw_add_regen", "0.15");
	pArmor = register_cvar("sw_armor", "70");
	pArmorLoss = register_cvar("sw_armor_loss", "30");
	pArmorRegenRate = register_cvar("sw_armor_regen_rate", "0.2");
	pArmorRegen = register_cvar("sw_armor_regen_", "3.0");
	pDmgMulti = register_cvar("sw_dmg_multiplier", "2.0");
	pMinSpeed = register_cvar("sw_min_speed", "850.0");
	pMaxSpeed = register_cvar("sw_max_speed", "1100.0");
//------Events and Messages
	register_event("CurWeapon", "evCurWeapon", "be");
	register_logevent("logevent_round_end", 2, "1=Round_End");
	register_logevent("logevent_round_start", 2, "1=Round_Start");
	register_logevent("logevent_round_restart", 2, "1&Restart_Round_", "1=Game_Commencing");
	register_event("DeathMsg", "evDeathMsg", "a");
	g_msg_icon = get_user_msgid("StatusIcon");
	g_msg_shadow = get_user_msgid("ShadowIdx");
	g_msg_ScreenFade = get_user_msgid("ScreenFade");
	g_msg_say_text = get_user_msgid ("SayText");
//------FakeMeta
	register_forward(FM_PlayerPostThink, "fwPostThink", 0);
	register_forward(FM_PlayerPreThink, "fwPreThink", 0);
//------HamSandwich
	RegisterHam(Ham_Spawn, "player", "fwHamSpawn", 1);
	RegisterHam(Ham_TakeDamage, "player", "fwHamTakeDmg", 0);
	RegisterHam(Ham_TakeDamage, "player", "fwHamTakeDmg_Post", 1);
	RegisterHam(Ham_Weapon_Reload, "weapon_m3", "fwHamReload_Post", 1);
	RegisterHam(Ham_Touch, "worldspawn", "fwHamTouchWall", 0);
	RegisterHam(Ham_Touch, "func_wall", "fwHamTouchWall", 0);
	RegisterHam(Ham_Touch, "func_breakable", "fwHamTouchWall", 0);
	RegisterHam(Ham_Touch, "func_wall_toggle", "fwHamTouchWall", 0);
	RegisterHam(Ham_Touch, "func_door", "fwHamTouchWall", 0);
	RegisterHam(Ham_Touch, "weaponbox", "fwHamTouchWeapon", 0);
	RegisterHam(Ham_Touch, "armoury_entity", "fwHamTouchWeapon", 0);
	RegisterHam(Ham_Touch, "player", "fwHamTouchPlayer", 0);
//------Other stuff
	server_cmd("sv_gravity 600");
	server_cmd("sv_airaccelerate 100");
	server_cmd("sv_maxspeed 999");
	server_exec();
	
	set_task(120.0, "Information", 0, _, _, "b");
}
//------Commands
public Upgrades(id){
	if (IsTrue(g_bChosen, id))
		return  PLUGIN_HANDLED;
	new menu = menu_create("Gun Upgrades", "GUHandler");
	static text[60];
	for (new i; i<sizeof(g_iWeapons); i++){
		formatex(text, charsmax(text), "\y[ \r%d\y ]\w %s", g_iWeapons[i], g_szWeapons[i]);
		menu_additem(menu, text);
	}
	menu_additem(menu, "default");
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);
	menu_display(id, menu);
	return PLUGIN_HANDLED;
}

public GUHandler(id, menu, item){
	if (item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	if (item < 5 && item > 0){
		g_iAirKills[id-1][0] = item+1;
	}
	else {
		g_iAirKills[id-1][0] = 0;
	}
	SetTrue(g_bChosen, id);
	g_iAirKills[id-1][1] = 0;
	static text[60];
	formatex(text, charsmax(text), "^x04[^x03%s^x04] ^x01 was chosen", g_szWeapons[item]);
	sendMSG(text, id);
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public Level(id){
	static text[60];
	formatex(text, charsmax(text), "Level \w(Pts: %d)", g_iPts[id-1]);
	new menu = menu_create(text, "LHandler");
	formatex(text, charsmax(text), "+%2d  Hp  \y[\r%2d\y]", get_pcvar_num(pAddHp), g_iHp[id-1]);
	menu_additem(menu, text);
	formatex(text, charsmax(text), "+%2d  Armor  \y[\r%2d\y]", get_pcvar_num(pAddArmor), g_iArmor[id-1]);
	menu_additem(menu, text);
	formatex(text, charsmax(text), "-%1.2f Regen  \y[\r%1.2f\y]", get_pcvar_float(pAddRegen), g_fRegen[id-1]);
	menu_additem(menu, text);
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL);
	menu_display(id, menu);
	return PLUGIN_HANDLED;
}

public LHandler(id, menu, item){
	if (item == MENU_EXIT){
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	if (g_iPts[id-1]){
		if (item == 0)
			g_iHp[id-1] += get_pcvar_num(pAddHp);
		else if (item == 1)
			g_iArmor[id-1] += get_pcvar_num(pAddArmor);
		else if (item == 2)
			g_fRegen[id-1] += get_pcvar_float(pAddRegen);
		g_iPts[id-1]--;
		menu_destroy(menu);
		if (g_iPts[id-1])
			Level(id);
	}
	else {
		menu_destroy(menu);
	}
	return PLUGIN_HANDLED;
}

public Drop(id){
	if (IsTrue(g_bStealth, id) && g_bStart && is_user_alive(id)){
		engclient_cmd(id, "weapon_knife");
		set_task(0.1, "Stealth", id);
		Sound(id);
	}
	return PLUGIN_HANDLED;
}
//------Events
public client_connect(id){
	ResetSettings(id);
	g_iLvl[id-1] = 0;
	g_iKills[id-1] = 0;
	g_iAirKills[id-1][0] = 0;
	g_iAirKills[id-1][1] = 0;
	g_iPts[id-1] = 0;
	g_iHp[id-1] = 0;
	g_iArmor[id-1] = 0;
	g_fRegen[id-1] = 0.0;
	SetFalse(g_bChosen, id);
	SetFalse(g_bHasGun, id);
	
}
public evCurWeapon(id){
	if (IsTrue(g_bInStealth, id))
		RemoveStealth(id);
	if (!is_user_alive(id))
		return;
	if (g_bStart)
		set_pev(id, pev_maxspeed, get_pcvar_float(pSpeed));
}

public logevent_round_end(){
	g_bStart = false;
	new pnum, players[32];
	get_players(players, pnum);
}

public logevent_round_start(){
	g_bStart = true;
	static pnum, players[32];
	get_players(players, pnum, "a");
	for (new i; i<pnum; i++)
		set_task(0.1, "Speed", players[i]+ID+ID);
}

public logevent_round_restart(){
	g_bStart = false;
	g_bChosen = 0;
	g_bHasGun = 0;
	for (new i; i<32; i++){
		g_iLvl[i] = 0;
		g_iKills[i] = 0;
		g_iAirKills[i][0] = 0;
		g_iAirKills[i][1] = 0;
		g_iPts[i] = 0;
		g_iHp[i] = 0;
		g_iArmor[i] = 0;
		g_fRegen[i] = 0.0;
	}
}

public evDeathMsg(){
	static att;
	att = read_data(1);
	if (!(pev(att, pev_flags) & FL_ONGROUND) && !IsTrue(g_bHasGun, att))
		g_iAirKills[att-1][1]++;
	if (g_iLvl[att-1] < 10){
		g_iKills[att-1]++;
		if ((g_iLvl[att-1]+2)/2 == g_iKills[att-1]){
			g_iLvl[att-1]++;
			g_iKills[att-1] = 0;
			g_iPts[att-1]++;
			Level(att);
		}
	}
}
//------FakeMeta
public fwPostThink(id){
	// Pushing players from each other
	
	// Preventing from fall damage
	if (is_user_alive(id) && is_user_connected(id) && IsTrue(g_bFalling, id))
		set_pev(id, pev_watertype, -3);
		
	// Removing buyzone
	set_pdata_int(id, OFFSET, get_pdata_int(id, OFFSET) & ~(1<<0));
	message_begin(MSG_ONE, g_msg_icon, _, id);
	write_byte(0);
	write_string("buyzone");
	message_end();
}

public fwPreThink(id){
	// Whether is user falling
	if (is_user_alive(id) && is_user_connected(id) && pev(id, pev_flFallVelocity) >= 350.0)
		SetTrue(g_bFalling, id);
	else
		SetFalse(g_bFalling, id);
	static obtn, nbtn;
	obtn = pev(id, pev_oldbuttons);
	nbtn = pev(id, pev_button);
	// Skipping one frame after jumping from ground (because of entities behaviour)
	if (IsTrue(g_bWallBlock, id))
		SetFalse(g_bWallBlock, id);
	if (nbtn & IN_JUMP && !(obtn & IN_JUMP) && pev(id, pev_flags) & FL_ONGROUND){
		pev(id, pev_velocity, g_fVelocity[id-1]);		// Sets base velocity and
		g_iJumpCount[id-1] = get_pcvar_num(pJumps);		// allowed jumps number
		SetTrue(g_bWallBlock, id);
	}
	// Wall jump performance
	// If user touched wall and pressed JUMP button
	if (IsTrue(g_bJump, id)){
		if (pev(id, pev_flags) & FL_ONGROUND){
		// If user is not in air wall jump doesn't count as performed
			SetFalse(g_bJump, id);
		}
		else {
			// Otherwise jump
			set_pev(id, pev_velocity, g_fVelocity[id-1]);
			g_iJumpCount[id-1]--;
			SetFalse(g_bJump, id);
		}
	}
	// Removing stealth if pressed attack
	if (IsTrue(g_bInStealth, id) && (nbtn & IN_ATTACK || nbtn & IN_ATTACK2)){
		if (task_exists(id))
			remove_task(id);
		RemoveStealth(id);
	}
	if (get_pcvar_num(pAutoBhop)){
		set_pev(id, pev_fuser2, 0.0);
		if (nbtn & IN_JUMP && obtn & IN_JUMP){
			new flags = pev(id, pev_flags);
			if (!(flags & FL_ONGROUND) || flags & FL_WATERJUMP || pev(id, pev_waterlevel) >=2)
				return PLUGIN_CONTINUE;
			new Float:velocity[3];
			pev(id, pev_velocity, velocity);
			velocity[2] += 240.0;
			set_pev(id, pev_velocity, velocity);
			set_pev(id, pev_gaitsequence, 6);
			g_iJumpCount[id-1]=0;	// If autobhop performed available jump count equal to 0
		}
	}
	// Checking whetehr player is allowed to pull up to other player
	if (nbtn & IN_USE && !(obtn & IN_USE)  && IsTrue(g_bPull, id)){
		new id2, body;
		static Float: vec1[3], Float: vec2[3];
		get_user_aiming(id, id2, body, get_pcvar_num(pPullDistance));
		if (is_user_connected(id2)){
			pev(id, pev_origin, vec1);
			pev(id2, pev_origin, vec2);
			xs_vec_sub(vec2, vec1, vec1);
			xs_vec_normalize(vec1, vec1);
			pev(id, pev_velocity, vec2);
			xs_vec_mul_scalar(vec1, xs_vec_len(vec2), vec1);
			set_pev(id, pev_velocity, vec1);
			SetFalse(g_bPull, id);
			set_task(get_pcvar_float(pPullCoolDown), "PullReset", id+PULL);
		}
	}
	return PLUGIN_CONTINUE;
}
//------Hamsandwich
public fwHamSpawn(id){
	ResetSettings(id);
	Weapons(id);
	Upgrades(id);
	if (is_user_alive(id) && g_bStart)
		set_pev(id, pev_maxspeed, get_pcvar_float(pSpeed));
}

public fwHamTakeDmg(vic, inf, att, Float:dmg, bit){
	// Stoping armor regeneration
	if (task_exists(vic+ARMOR))
		remove_task(vic+ARMOR);
	// Setting time untill when armor regeneration starts
	set_task(get_pcvar_float(pArmorRegen)-g_fRegen[vic-1], "ArmorRegen", vic+ARMOR);
	// Removing Knockback
	pev(vic, pev_velocity, g_Knockback[vic-1]);
	static Float: fSpeed;
	pev(att, pev_maxspeed, fSpeed);
	// Setting damage based on speed and multiplier
	new bool: somethingWasDone;
	new Float: damage = dmg;
	if (fSpeed > get_pcvar_float(pMinSpeed)){
		if (fSpeed > get_pcvar_float(pMaxSpeed))
			damage = dmg*get_pcvar_float(pDmgMulti);
		else 
			damage = dmg*(get_pcvar_float(pDmgMulti)/((get_pcvar_float(pMaxSpeed)-get_pcvar_float(pMinSpeed))/fSpeed));
		somethingWasDone = true;
	}
	// Sets ammount of armor left
	// If armour equals 0, then execute damage normaly.
	if (get_user_armor(vic)>0){
		if (get_user_armor(vic) > floatround(damage))
			set_user_armor(vic, get_user_armor(vic)-floatround(damage))
		else
			ArmorBreak(vic);
		SetHamParamFloat(4, 0.0);
		somethingWasDone = true;
	}
	else if (fSpeed > get_pcvar_float(pMinSpeed))
		SetHamParamFloat(4, damage);
	
	if (somethingWasDone)
		return HAM_HANDLED;
	return HAM_IGNORED;	
}

public fwHamTakeDmg_Post(vic, inf, att, Float:dmg, bit){
	// calcolation for removal of knockback
	if (is_user_alive(vic)){
		static Float:push[3];
		pev(vic, pev_velocity, push);
		xs_vec_sub(push, g_Knockback[vic-1], push);
		xs_vec_mul_scalar(push, 0.0, push);
		xs_vec_add(push, g_Knockback[vic-1], push);
		set_pev(vic, pev_velocity, push);
	}
}

public fwHamReload_Post(iEnt){
	// Unlimited ammo
	cs_set_user_bpammo(pev(iEnt, pev_owner), CSW_M3, 32);
}

public fwHamTouchWall(iEnt, id){
// Wall jump stuff
	// If user is touching wall, not on ground, has some wall jumps left and currently  in jump
	if (is_user_alive(id) && !(pev(id, pev_flags) & FL_ONGROUND) && g_iJumpCount[id-1]
	     && pev(id, pev_button) & IN_JUMP && !IsTrue(g_bWallBlock, id)){
	     	// Reverse velocity on X axis
		g_fVelocity[id-1][0] *= (-1);
		// Set velocity upwards equal to 300.0 units/s
		g_fVelocity[id-1][2] = 300.0;
		SetTrue(g_bJump, id);
	}
}

public fwHamTouchWeapon(iEnt, id){
	// Disable picking up guns
	return HAM_SUPERCEDE;
}

public fwHamTouchPlayer(iEnt, id){
	// Push player from different teams away from each other
	if (IsTrue(g_bPushPerformed, id)){
		SetFalse(g_bPushPerformed, id);
		SetFalse(g_bPushPerformed, iEnt);
	}
	else if (is_user_alive(id) && is_user_alive(iEnt) && get_user_team(id) != get_user_team(iEnt)){
		static Float: fVel1[3], Float: fVel2[3], Float: fVel3[3], Float: fSpeed;
		pev(iEnt, pev_velocity, fVel1);
		pev(id, pev_velocity, fVel2);
		xs_vec_sub(fVel2, fVel1, fVel3);
		fSpeed = xs_vec_len(fVel3);
		if (fSpeed > 800.0){
			SetTrue(g_bPushPerformed, id);
			SetTrue(g_bPushPerformed, iEnt);
			static Float: fOr1[3], Float: fOr2[3], Float: fOr3[3];
			pev(iEnt, pev_origin, fOr1);
			pev(id, pev_origin, fOr2);
			xs_vec_add(fOr1, fOr2, fOr3);
			xs_vec_mul_scalar(fOr3, 0.5, fOr3);
			xs_vec_sub(fOr2, fOr1, fOr1);
			xs_vec_normalize(fOr1, fOr1);
			xs_vec_mul_scalar(fOr1, fSpeed, fVel3);
			xs_vec_add(fVel2, fVel3, fVel2);
			xs_vec_sub(fVel1, fVel3, fVel1);
			set_pev(iEnt, pev_velocity, fVel1);
			set_pev(id, pev_velocity, fVel2);
			if (get_user_armor(iEnt) < get_pcvar_num(pArmorLoss))
				ArmorBreak(iEnt);
			else 
				set_user_armor(iEnt, (get_user_armor(iEnt) - get_pcvar_num(pArmorLoss)));
			if (get_user_armor(id) < get_pcvar_num(pArmorLoss))
				ArmorBreak(id);
			else 
				set_user_armor(id, (get_user_armor(id) - get_pcvar_num(pArmorLoss)));
			if(task_exists(id+ARMOR))
				remove_task(id+ARMOR);
			set_task(get_pcvar_float(pArmorRegen)-g_fRegen[id-1], "ArmorRegen", id+ARMOR);
			if(task_exists(iEnt+ARMOR))
				remove_task(iEnt+ARMOR);
			set_task(get_pcvar_float(pArmorRegen)-g_fRegen[iEnt-1], "ArmorRegen", iEnt+ARMOR);
			// sound on collision
			new ent = create_entity("info_target");
			set_pev(ent, pev_origin, fOr3);
			emit_sound(ent, CHAN_STATIC, g_szSoundRic, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
			set_task(1.0, "RemoveSound2", ent);
		}
	}
}

//------Custom Functions
Weapons(id){
	if (!is_user_alive(id))
		return;
	strip_user_weapons(id);
	give_item(id, "weapon_knife");
	give_item(id, "weapon_m3");
	cs_set_user_bpammo(id, CSW_M3, 32);
	set_user_armor(id, get_pcvar_num(pArmor)+g_iArmor[id-1]);
	set_user_health(id, 100+g_iHp[id-1]);
}

Render(id){
	// Player starts glowing in team color
	//set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,0);
	if (get_user_team(id) == 1)
		set_rendering(id,kRenderFxGlowShell,255,0,0,kRenderNormal,15);
	else if (get_user_team(id) == 2)
		set_rendering(id,kRenderFxGlowShell,0,0,255,kRenderNormal,15);
	// Remove shadow
	message_begin(MSG_ONE_UNRELIABLE, g_msg_shadow, _, id);
	write_long(0);
	message_end();
}

public Stealth(id){
	if (!is_user_alive(id))
		return;
	// Set player to stealth mode	
	set_user_rendering(id,kRenderFxNone,0,0,0,kRenderNormal,0);
	set_user_rendering(id,kRenderFxNone,0,0,0,kRenderTransAlpha,0);
	Light(id);
	// Some sounds should be here
	SetFalse(g_bStealth, id);
	SetTrue(g_bInStealth, id);
	set_task(get_pcvar_float(pStealthTime), "RemoveStealth", id);
}

public RemoveStealth(id){
	SetFalse(g_bInStealth, id);
	static Float: fOrigin[3];
	new ent = create_entity("info_target");
	pev(id, pev_origin, fOrigin);
	set_pev(ent, pev_origin, fOrigin);
	emit_sound(ent, CHAN_STATIC, g_szSoundVanishReverse, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	set_task(1.0, "RemoveSound3", ent);
	if (task_exists(id))
		remove_task(id);
	set_task(get_pcvar_float(pStealthCoolDown), "StealthReset", id+ID);
	if (is_user_alive(id))
		Render(id);
}

public StealthReset(id){
	SetTrue(g_bStealth, id-ID);
}

public Speed(id){
	set_pev(id-ID-ID, pev_maxspeed, get_pcvar_float(pSpeed));
}

ResetSettings(id){
	if (task_exists(id))
		remove_task(id);
	if (task_exists(id+ID))
		remove_task(id+ID);
	if (task_exists(id+PULL))
		remove_task(id+PULL);
	if (task_exists(id+ARMOR))
		remove_task(id+ARMOR);
	Render(id);
	SetFalse(g_bInStealth, id);
	SetTrue(g_bStealth, id);
	SetTrue(g_bPull, id);
	SetTrue(g_bScreenFade, id);
}

ArmorBreak(id){
	set_user_armor(id, 0);
	// Breaking sound
	// Effects
	
}

public ArmorRegen(id){
	if (IsTrue(g_bScreenFade, id-ARMOR)){
		message_begin(MSG_ONE_UNRELIABLE, g_msg_ScreenFade, _, id-ARMOR)
		write_short(512);
		write_short(512);
		write_short(0x0000);
		write_byte(0);
		write_byte(0);
		write_byte(255);
		write_byte(70);
		message_end();
		// some sounds also should be included, but that's next time
		SetFalse(g_bScreenFade, id-ARMOR);
	}
	set_user_armor(id-ARMOR, get_user_armor(id-ARMOR)+1);
	if (get_user_armor(id-ARMOR) < get_pcvar_num(pArmor))
		set_task(get_pcvar_float(pArmorRegenRate), "ArmorRegen", id);
	else
		SetTrue(g_bScreenFade, id-ARMOR);
}

public Light(id){
	// Creates light which fades away
	static  origin[3];
	get_user_origin(id, origin);
	message_begin(MSG_ALL, SVC_TEMPENTITY, origin);
	write_byte(TE_DLIGHT);
	write_coord(origin[0]);	// x
	write_coord(origin[1]);	// y
	write_coord(origin[2]);	// z
	write_byte(40);		// Distance
	if (get_user_team(id) == 1){
		write_byte(255);	// R
		write_byte(0);		// G
		write_byte(0);		// B
	}
	else {
		write_byte(0);		// R
		write_byte(0);		// G
		write_byte(255);	// B
	}
	write_byte(20);		// life in 0.1's
	write_byte(50);		// decay rate (0.1 s)
	message_end();
}

public Sound(id){
	static Float: fOrigin[3];
	new ent = create_entity("info_target");
	pev(id, pev_origin, fOrigin);
	set_pev(ent, pev_origin, fOrigin);
	emit_sound(ent, CHAN_STATIC, g_szSoundVanish, VOL_NORM, ATTN_NORM, 0, PITCH_NORM);
	set_task(1.0, "RemoveSound", ent);
}

public RemoveSound(id){
	emit_sound(id, CHAN_STATIC, g_szSoundVanish, VOL_NORM, ATTN_NORM, SND_STOP, PITCH_NORM);
	remove_entity(id);
}

public RemoveSound2(id){
	emit_sound(id, CHAN_STATIC, g_szSoundRic, VOL_NORM, ATTN_NORM, SND_STOP, PITCH_NORM);
	remove_entity(id);
}

public RemoveSound3(id){
	emit_sound(id, CHAN_STATIC, g_szSoundVanishReverse, VOL_NORM, ATTN_NORM, SND_STOP, PITCH_NORM);
	remove_entity(id);
}

public PullReset(id){
	SetTrue(g_bPull, id-PULL);
}

public sendMSG(text[], id){
	message_begin (MSG_ONE, g_msg_say_text, {0, 0, 0}, id);
	write_byte (id);
	write_string (text);
	message_end();
}
